/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.10.v201611111521.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Adapter_STUB_DEFAULT_HPP_
#define V4_ORG_BLUEZ_Adapter_STUB_DEFAULT_HPP_


#include <CommonAPI/Export.hpp>

#include <v4/org/bluez/AdapterStub.hpp>
#include <sstream>

#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif

namespace v4 {
namespace org {
namespace bluez {

/**
 * Provides a default implementation for AdapterStubRemoteEvent and
 * AdapterStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class COMMONAPI_EXPORT_CLASS_EXPLICIT AdapterStubDefault
    : public virtual AdapterStub {
public:
    COMMONAPI_EXPORT AdapterStubDefault();

    COMMONAPI_EXPORT AdapterStubRemoteEvent* initStubAdapter(const std::shared_ptr< AdapterStubAdapter> &_adapter);

    COMMONAPI_EXPORT const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client);


    COMMONAPI_EXPORT virtual void GetProperties(const std::shared_ptr<CommonAPI::ClientId> _client, GetPropertiesReply_t _reply);
    COMMONAPI_EXPORT virtual void SetProperty(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _name, Adapter::Variant _value, SetPropertyReply_t _reply);
    COMMONAPI_EXPORT virtual void RequestSession(const std::shared_ptr<CommonAPI::ClientId> _client, RequestSessionReply_t _reply);
    COMMONAPI_EXPORT virtual void ReleaseSession(const std::shared_ptr<CommonAPI::ClientId> _client, ReleaseSessionReply_t _reply);
    COMMONAPI_EXPORT virtual void StartDiscovery(const std::shared_ptr<CommonAPI::ClientId> _client, StartDiscoveryReply_t _reply);
    COMMONAPI_EXPORT virtual void StopDiscovery(const std::shared_ptr<CommonAPI::ClientId> _client, StopDiscoveryReply_t _reply);
    COMMONAPI_EXPORT virtual void ListDevices(const std::shared_ptr<CommonAPI::ClientId> _client, ListDevicesReply_t _reply);
    COMMONAPI_EXPORT virtual void CreateDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, CreateDeviceReply_t _reply);
    COMMONAPI_EXPORT virtual void CreatePairedDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, std::string _agent, std::string _capability, CreatePairedDeviceReply_t _reply);
    COMMONAPI_EXPORT virtual void CancelDeviceCreation(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, CancelDeviceCreationReply_t _reply);
    COMMONAPI_EXPORT virtual void RemoveDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _device, RemoveDeviceReply_t _reply);
    COMMONAPI_EXPORT virtual void FindDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, FindDeviceReply_t _reply);
    COMMONAPI_EXPORT virtual void RegisterAgent(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _agent, std::string _capability, RegisterAgentReply_t _reply);
    COMMONAPI_EXPORT virtual void UnregisterAgent(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _agent, UnregisterAgentReply_t _reply);

    COMMONAPI_EXPORT virtual void firePropertyChangedEvent(const std::string &_name, const ::v4::org::bluez::Adapter::Variant &_value);
    COMMONAPI_EXPORT virtual void fireDeviceCreatedEvent(const std::string &_device);
    COMMONAPI_EXPORT virtual void fireDeviceRemovedEvent(const std::string &_device);
    COMMONAPI_EXPORT virtual void fireDeviceFoundEvent(const std::string &_address, const ::v4::org::bluez::Adapter::tDeviceFound_valuesDict &_values);
    COMMONAPI_EXPORT virtual void fireDeviceDisappearedEvent(const std::string &_address);

    
protected:
    class COMMONAPI_EXPORT_CLASS_EXPLICIT RemoteEventHandler: public virtual AdapterStubRemoteEvent {
    public:
        COMMONAPI_EXPORT RemoteEventHandler(AdapterStubDefault *_defaultStub);


    private:
        AdapterStubDefault *defaultStub_;
    };
private:
    AdapterStubDefault::RemoteEventHandler remoteEventHandler_;


    CommonAPI::Version interfaceVersion_;
};

} // namespace bluez
} // namespace org
} // namespace v4


// Compatibility
namespace v4_1 = v4;

#endif // V4_ORG_BLUEZ_Adapter_STUB_DEFAULT
