/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.10.v201611111523.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Adapter_DBUS_STUB_ADAPTER_HPP_
#define V4_ORG_BLUEZ_Adapter_DBUS_STUB_ADAPTER_HPP_

#include <v4/org/bluez/AdapterStub.hpp>
#include "v4/org/bluez/AdapterDBusDeployment.hpp"
#include <v4/org/bluez/AdapterDBusDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/DBus/DBusAddressTranslator.hpp>
#include <CommonAPI/DBus/DBusFactory.hpp>
#include <CommonAPI/DBus/DBusStubAdapterHelper.hpp>
#include <CommonAPI/DBus/DBusStubAdapter.hpp>
#include <CommonAPI/DBus/DBusDeployment.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v4 {
namespace org {
namespace bluez {

template <typename _Stub = ::v4::org::bluez::AdapterStub, typename... _Stubs>
class AdapterDBusStubAdapterInternal
    : public virtual AdapterStubAdapter,
      public CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...>
     {
public:
    typedef CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...> AdapterDBusStubAdapterHelper;

    ~AdapterDBusStubAdapterInternal() {
        deactivateManagedInstances();
        AdapterDBusStubAdapterHelper::deinit();
    }

    virtual bool hasFreedesktopProperties() {
        return false;
    }

    inline static const char* getInterface() {
        return Adapter::getInterface();
    }

    void firePropertyChangedEvent(const std::string& name, const ::v4::org::bluez::Adapter::Variant& value);

    void fireDeviceCreatedEvent(const std::string& device);

    void fireDeviceRemovedEvent(const std::string& device);

    void fireDeviceFoundEvent(const std::string& address, const ::v4::org::bluez::Adapter::tDeviceFound_valuesDict& values);

    void fireDeviceDisappearedEvent(const std::string& address);

    void deactivateManagedInstances() {
    }

    static CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        CommonAPI::Version
        > getAdapterInterfaceVersionStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< >,
        std::tuple< Adapter::tGetProperties_propertiesDict>,
        std::tuple< >,
        std::tuple< ::v4::org::bluez::Adapter_::tGetProperties_propertiesDictDeployment_t>
    
        > getPropertiesStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< std::string, Adapter::Variant>,
        std::tuple< >,
        std::tuple< CommonAPI::DBus::StringDeployment, ::v4::org::bluez::Adapter_::VariantDeployment_t>,
        std::tuple< >
    
        > setPropertyStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< >,
        std::tuple< >,
        std::tuple< >,
        std::tuple< >
    
        > requestSessionStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< >,
        std::tuple< >,
        std::tuple< >,
        std::tuple< >
    
        > releaseSessionStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< >,
        std::tuple< >,
        std::tuple< >,
        std::tuple< >
    
        > startDiscoveryStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< >,
        std::tuple< >,
        std::tuple< >,
        std::tuple< >
    
        > stopDiscoveryStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< >,
        std::tuple< std::vector< std::string >>,
        std::tuple< >,
        std::tuple< CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >>
    
        > listDevicesStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< std::string>,
        std::tuple< std::string>,
        std::tuple< CommonAPI::DBus::StringDeployment>,
        std::tuple< CommonAPI::DBus::StringDeployment>
    
        > createDeviceStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< std::string, std::string, std::string>,
        std::tuple< std::string>,
        std::tuple< CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment>,
        std::tuple< CommonAPI::DBus::StringDeployment>
    
        > createPairedDeviceStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< std::string>,
        std::tuple< >,
        std::tuple< CommonAPI::DBus::StringDeployment>,
        std::tuple< >
    
        > cancelDeviceCreationStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< std::string>,
        std::tuple< >,
        std::tuple< CommonAPI::DBus::StringDeployment>,
        std::tuple< >
    
        > removeDeviceStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< std::string>,
        std::tuple< std::string>,
        std::tuple< CommonAPI::DBus::StringDeployment>,
        std::tuple< CommonAPI::DBus::StringDeployment>
    
        > findDeviceStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< std::string, std::string>,
        std::tuple< >,
        std::tuple< CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment>,
        std::tuple< >
    
        > registerAgentStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        std::tuple< std::string>,
        std::tuple< >,
        std::tuple< CommonAPI::DBus::StringDeployment>,
        std::tuple< >
    
        > unregisterAgentStubDispatcher;






    AdapterDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
    : CommonAPI::DBus::DBusStubAdapter(_address, _connection,false),
      AdapterDBusStubAdapterHelper(_address, _connection, false, _stub) {
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "GetProperties", "" }, &getPropertiesStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "SetProperty", "s(yv)" }, &setPropertyStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "RequestSession", "" }, &requestSessionStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "ReleaseSession", "" }, &releaseSessionStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "StartDiscovery", "" }, &startDiscoveryStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "StopDiscovery", "" }, &stopDiscoveryStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "ListDevices", "" }, &listDevicesStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "CreateDevice", "s" }, &createDeviceStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "CreatePairedDevice", "sss" }, &createPairedDeviceStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "CancelDeviceCreation", "s" }, &cancelDeviceCreationStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "RemoveDevice", "s" }, &removeDeviceStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "FindDevice", "s" }, &findDeviceStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "RegisterAgent", "ss" }, &registerAgentStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "UnregisterAgent", "s" }, &unregisterAgentStubDispatcher);
        AdapterDBusStubAdapterHelper::addStubDispatcher({ "getInterfaceVersion", "" }, &getAdapterInterfaceVersionStubDispatcher);
    }

protected:
    virtual const char* getMethodsDBusIntrospectionXmlData() const {
        static const std::string introspectionData =
            "<method name=\"getInterfaceVersion\">\n"
                "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
            "</method>\n"
            "<signal name=\"PropertyChanged\">\n"
            "<arg name=\"name\" type=\"s\" />\n"
            "<arg name=\"value\" type=\"(yv)\" />\n"
            "</signal>\n"
            "<signal name=\"DeviceCreated\">\n"
            "<arg name=\"device\" type=\"s\" />\n"
            "</signal>\n"
            "<signal name=\"DeviceRemoved\">\n"
            "<arg name=\"device\" type=\"s\" />\n"
            "</signal>\n"
            "<signal name=\"DeviceFound\">\n"
            "<arg name=\"address\" type=\"s\" />\n"
            "<arg name=\"values\" type=\"a{s(yv)}\" />\n"
            "</signal>\n"
            "<signal name=\"DeviceDisappeared\">\n"
            "<arg name=\"address\" type=\"s\" />\n"
            "</signal>\n"
            "<method name=\"GetProperties\">\n"
            "<arg name=\"_properties\" type=\"a{s(yv)}\" direction=\"out\" />\n"
            "</method>\n"
            "<method name=\"SetProperty\">\n"
            "<arg name=\"_name\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_value\" type=\"(yv)\" direction=\"in\" />\n"
            "</method>\n"
            "<method name=\"RequestSession\">\n"
            "</method>\n"
            "<method name=\"ReleaseSession\">\n"
            "</method>\n"
            "<method name=\"StartDiscovery\">\n"
            "</method>\n"
            "<method name=\"StopDiscovery\">\n"
            "</method>\n"
            "<method name=\"ListDevices\">\n"
            "<arg name=\"_devices\" type=\"as\" direction=\"out\" />\n"
            "</method>\n"
            "<method name=\"CreateDevice\">\n"
            "<arg name=\"_address\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_device\" type=\"s\" direction=\"out\" />\n"
            "</method>\n"
            "<method name=\"CreatePairedDevice\">\n"
            "<arg name=\"_address\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_agent\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_capability\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_device\" type=\"s\" direction=\"out\" />\n"
            "</method>\n"
            "<method name=\"CancelDeviceCreation\">\n"
            "<arg name=\"_address\" type=\"s\" direction=\"in\" />\n"
            "</method>\n"
            "<method name=\"RemoveDevice\">\n"
            "<arg name=\"_device\" type=\"s\" direction=\"in\" />\n"
            "</method>\n"
            "<method name=\"FindDevice\">\n"
            "<arg name=\"_address\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_device\" type=\"s\" direction=\"out\" />\n"
            "</method>\n"
            "<method name=\"RegisterAgent\">\n"
            "<arg name=\"_agent\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_capability\" type=\"s\" direction=\"in\" />\n"
            "</method>\n"
            "<method name=\"UnregisterAgent\">\n"
            "<arg name=\"_agent\" type=\"s\" direction=\"in\" />\n"
            "</method>\n"
            ;
        return introspectionData.c_str();
    }

private:
};


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    CommonAPI::Version
    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::getAdapterInterfaceVersionStubDispatcher(&AdapterStub::getInterfaceVersion, "uu");


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< >,
    std::tuple< Adapter::tGetProperties_propertiesDict>,
    std::tuple< >,
    std::tuple< ::v4::org::bluez::Adapter_::tGetProperties_propertiesDictDeployment_t>

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::getPropertiesStubDispatcher(
    &AdapterStub::GetProperties, "a{s(yv)}",
    std::make_tuple(),
    std::make_tuple(static_cast< ::v4::org::bluez::Adapter_::tGetProperties_propertiesDictDeployment_t* >(nullptr)));


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< std::string, Adapter::Variant>,
    std::tuple< >,
    std::tuple< CommonAPI::DBus::StringDeployment, ::v4::org::bluez::Adapter_::VariantDeployment_t>,
    std::tuple< >

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::setPropertyStubDispatcher(
    &AdapterStub::SetProperty, "",
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr), static_cast< ::v4::org::bluez::Adapter_::VariantDeployment_t* >(nullptr)),
    std::make_tuple());


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< >,
    std::tuple< >,
    std::tuple< >,
    std::tuple< >

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::requestSessionStubDispatcher(
    &AdapterStub::RequestSession, "",
    std::make_tuple(),
    std::make_tuple());


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< >,
    std::tuple< >,
    std::tuple< >,
    std::tuple< >

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::releaseSessionStubDispatcher(
    &AdapterStub::ReleaseSession, "",
    std::make_tuple(),
    std::make_tuple());


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< >,
    std::tuple< >,
    std::tuple< >,
    std::tuple< >

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::startDiscoveryStubDispatcher(
    &AdapterStub::StartDiscovery, "",
    std::make_tuple(),
    std::make_tuple());


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< >,
    std::tuple< >,
    std::tuple< >,
    std::tuple< >

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::stopDiscoveryStubDispatcher(
    &AdapterStub::StopDiscovery, "",
    std::make_tuple(),
    std::make_tuple());


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< >,
    std::tuple< std::vector< std::string >>,
    std::tuple< >,
    std::tuple< CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >>

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::listDevicesStubDispatcher(
    &AdapterStub::ListDevices, "as",
    std::make_tuple(),
    std::make_tuple(static_cast< CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >* >(nullptr)));


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< std::string>,
    std::tuple< std::string>,
    std::tuple< CommonAPI::DBus::StringDeployment>,
    std::tuple< CommonAPI::DBus::StringDeployment>

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::createDeviceStubDispatcher(
    &AdapterStub::CreateDevice, "s",
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)));


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< std::string, std::string, std::string>,
    std::tuple< std::string>,
    std::tuple< CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment>,
    std::tuple< CommonAPI::DBus::StringDeployment>

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::createPairedDeviceStubDispatcher(
    &AdapterStub::CreatePairedDevice, "s",
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr), static_cast< CommonAPI::DBus::StringDeployment* >(nullptr), static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)));


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< std::string>,
    std::tuple< >,
    std::tuple< CommonAPI::DBus::StringDeployment>,
    std::tuple< >

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::cancelDeviceCreationStubDispatcher(
    &AdapterStub::CancelDeviceCreation, "",
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    std::make_tuple());


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< std::string>,
    std::tuple< >,
    std::tuple< CommonAPI::DBus::StringDeployment>,
    std::tuple< >

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::removeDeviceStubDispatcher(
    &AdapterStub::RemoveDevice, "",
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    std::make_tuple());


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< std::string>,
    std::tuple< std::string>,
    std::tuple< CommonAPI::DBus::StringDeployment>,
    std::tuple< CommonAPI::DBus::StringDeployment>

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::findDeviceStubDispatcher(
    &AdapterStub::FindDevice, "s",
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)));


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< std::string, std::string>,
    std::tuple< >,
    std::tuple< CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment>,
    std::tuple< >

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::registerAgentStubDispatcher(
    &AdapterStub::RegisterAgent, "",
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr), static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    std::make_tuple());


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple< std::string>,
    std::tuple< >,
    std::tuple< CommonAPI::DBus::StringDeployment>,
    std::tuple< >

    > AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::unregisterAgentStubDispatcher(
    &AdapterStub::UnregisterAgent, "",
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    std::make_tuple());

template <typename _Stub, typename... _Stubs>
void AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::firePropertyChangedEvent(const std::string& name, const ::v4::org::bluez::Adapter::Variant& value) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>,
    CommonAPI::Deployable< ::v4::org::bluez::Adapter::Variant, ::v4::org::bluez::Adapter_::VariantDeployment_t>
    >>::sendSignal(
            *this,
            "PropertyChanged",
            "s(yv)",
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>(name, static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    CommonAPI::Deployable< ::v4::org::bluez::Adapter::Variant, ::v4::org::bluez::Adapter_::VariantDeployment_t>(value, static_cast< ::v4::org::bluez::Adapter_::VariantDeployment_t* >(nullptr))
    );
}

template <typename _Stub, typename... _Stubs>
void AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::fireDeviceCreatedEvent(const std::string& device) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "DeviceCreated",
            "s",
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>(device, static_cast< CommonAPI::DBus::StringDeployment* >(nullptr))
    );
}

template <typename _Stub, typename... _Stubs>
void AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::fireDeviceRemovedEvent(const std::string& device) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "DeviceRemoved",
            "s",
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>(device, static_cast< CommonAPI::DBus::StringDeployment* >(nullptr))
    );
}

template <typename _Stub, typename... _Stubs>
void AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::fireDeviceFoundEvent(const std::string& address, const ::v4::org::bluez::Adapter::tDeviceFound_valuesDict& values) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>,
    CommonAPI::Deployable< ::v4::org::bluez::Adapter::tDeviceFound_valuesDict, ::v4::org::bluez::Adapter_::tDeviceFound_valuesDictDeployment_t>
    >>::sendSignal(
            *this,
            "DeviceFound",
            "sa{s(yv)}",
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>(address, static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    CommonAPI::Deployable< ::v4::org::bluez::Adapter::tDeviceFound_valuesDict, ::v4::org::bluez::Adapter_::tDeviceFound_valuesDictDeployment_t>(values, static_cast< ::v4::org::bluez::Adapter_::tDeviceFound_valuesDictDeployment_t* >(nullptr))
    );
}

template <typename _Stub, typename... _Stubs>
void AdapterDBusStubAdapterInternal<_Stub, _Stubs...>::fireDeviceDisappearedEvent(const std::string& address) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "DeviceDisappeared",
            "s",
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>(address, static_cast< CommonAPI::DBus::StringDeployment* >(nullptr))
    );
}


template <typename _Stub = ::v4::org::bluez::AdapterStub, typename... _Stubs>
class AdapterDBusStubAdapter
    : public AdapterDBusStubAdapterInternal<_Stub, _Stubs...>,
      public std::enable_shared_from_this< AdapterDBusStubAdapter<_Stub, _Stubs...>> {
public:
    AdapterDBusStubAdapter(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
        : CommonAPI::DBus::DBusStubAdapter(
            _address,
            _connection,
            false),
          AdapterDBusStubAdapterInternal<_Stub, _Stubs...>(
            _address,
            _connection,
            _stub) {
    }
};

} // namespace bluez
} // namespace org
} // namespace v4

#endif // V4_ORG_BLUEZ_Adapter_DBUS_STUB_ADAPTER_HPP_
