/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.10.v201611111523.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Manager_DBUS_STUB_ADAPTER_HPP_
#define V4_ORG_BLUEZ_Manager_DBUS_STUB_ADAPTER_HPP_

#include <v4/org/bluez/ManagerStub.hpp>
#include "v4/org/bluez/ManagerDBusDeployment.hpp"
#include <v4/org/bluez/ManagerDBusDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/DBus/DBusAddressTranslator.hpp>
#include <CommonAPI/DBus/DBusFactory.hpp>
#include <CommonAPI/DBus/DBusStubAdapterHelper.hpp>
#include <CommonAPI/DBus/DBusStubAdapter.hpp>
#include <CommonAPI/DBus/DBusDeployment.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v4 {
namespace org {
namespace bluez {

template <typename _Stub = ::v4::org::bluez::ManagerStub, typename... _Stubs>
class ManagerDBusStubAdapterInternal
    : public virtual ManagerStubAdapter,
      public CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...>
     {
public:
    typedef CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...> ManagerDBusStubAdapterHelper;

    ~ManagerDBusStubAdapterInternal() {
        deactivateManagedInstances();
        ManagerDBusStubAdapterHelper::deinit();
    }

    virtual bool hasFreedesktopProperties() {
        return false;
    }

    inline static const char* getInterface() {
        return Manager::getInterface();
    }

    void firePropertyChangedEvent(const std::string& name, const ::v4::org::bluez::Manager::Variant& value);

    void fireAdapterAddedEvent(const std::string& adapter);

    void fireAdapterRemovedEvent(const std::string& adapter);

    void fireDefaultAdapterChangedEvent(const std::string& adapter);

    void deactivateManagedInstances() {
    }

    static CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v4::org::bluez::ManagerStub,
        CommonAPI::Version
        > getManagerInterfaceVersionStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::ManagerStub,
        std::tuple< >,
        std::tuple< Manager::tGetProperties_propertiesDict>,
        std::tuple< >,
        std::tuple< ::v4::org::bluez::Manager_::tGetProperties_propertiesDictDeployment_t>
    
        > getPropertiesStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::ManagerStub,
        std::tuple< >,
        std::tuple< std::string>,
        std::tuple< >,
        std::tuple< CommonAPI::DBus::StringDeployment>
    
        > defaultAdapterStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::ManagerStub,
        std::tuple< std::string>,
        std::tuple< std::string>,
        std::tuple< CommonAPI::DBus::StringDeployment>,
        std::tuple< CommonAPI::DBus::StringDeployment>
    
        > findAdapterStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v4::org::bluez::ManagerStub,
        std::tuple< >,
        std::tuple< std::vector< std::string >>,
        std::tuple< >,
        std::tuple< CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >>
    
        > listAdaptersStubDispatcher;





    ManagerDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
    : CommonAPI::DBus::DBusStubAdapter(_address, _connection,false),
      ManagerDBusStubAdapterHelper(_address, _connection, false, _stub) {
        ManagerDBusStubAdapterHelper::addStubDispatcher({ "GetProperties", "" }, &getPropertiesStubDispatcher);
        ManagerDBusStubAdapterHelper::addStubDispatcher({ "DefaultAdapter", "" }, &defaultAdapterStubDispatcher);
        ManagerDBusStubAdapterHelper::addStubDispatcher({ "FindAdapter", "s" }, &findAdapterStubDispatcher);
        ManagerDBusStubAdapterHelper::addStubDispatcher({ "ListAdapters", "" }, &listAdaptersStubDispatcher);
        ManagerDBusStubAdapterHelper::addStubDispatcher({ "getInterfaceVersion", "" }, &getManagerInterfaceVersionStubDispatcher);
    }

protected:
    virtual const char* getMethodsDBusIntrospectionXmlData() const {
        static const std::string introspectionData =
            "<method name=\"getInterfaceVersion\">\n"
                "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
            "</method>\n"
            "<signal name=\"PropertyChanged\">\n"
            "<arg name=\"name\" type=\"s\" />\n"
            "<arg name=\"value\" type=\"(yv)\" />\n"
            "</signal>\n"
            "<signal name=\"AdapterAdded\">\n"
            "<arg name=\"adapter\" type=\"s\" />\n"
            "</signal>\n"
            "<signal name=\"AdapterRemoved\">\n"
            "<arg name=\"adapter\" type=\"s\" />\n"
            "</signal>\n"
            "<signal name=\"DefaultAdapterChanged\">\n"
            "<arg name=\"adapter\" type=\"s\" />\n"
            "</signal>\n"
            "<method name=\"GetProperties\">\n"
            "<arg name=\"_properties\" type=\"a{s(yv)}\" direction=\"out\" />\n"
            "</method>\n"
            "<method name=\"DefaultAdapter\">\n"
            "<arg name=\"_adapter\" type=\"s\" direction=\"out\" />\n"
            "</method>\n"
            "<method name=\"FindAdapter\">\n"
            "<arg name=\"_pattern\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_adapter\" type=\"s\" direction=\"out\" />\n"
            "</method>\n"
            "<method name=\"ListAdapters\">\n"
            "<arg name=\"_adapters\" type=\"as\" direction=\"out\" />\n"
            "</method>\n"
            ;
        return introspectionData.c_str();
    }

private:
};


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
    ::v4::org::bluez::ManagerStub,
    CommonAPI::Version
    > ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::getManagerInterfaceVersionStubDispatcher(&ManagerStub::getInterfaceVersion, "uu");


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::ManagerStub,
    std::tuple< >,
    std::tuple< Manager::tGetProperties_propertiesDict>,
    std::tuple< >,
    std::tuple< ::v4::org::bluez::Manager_::tGetProperties_propertiesDictDeployment_t>

    > ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::getPropertiesStubDispatcher(
    &ManagerStub::GetProperties, "a{s(yv)}",
    std::make_tuple(),
    std::make_tuple(static_cast< ::v4::org::bluez::Manager_::tGetProperties_propertiesDictDeployment_t* >(nullptr)));


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::ManagerStub,
    std::tuple< >,
    std::tuple< std::string>,
    std::tuple< >,
    std::tuple< CommonAPI::DBus::StringDeployment>

    > ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::defaultAdapterStubDispatcher(
    &ManagerStub::DefaultAdapter, "s",
    std::make_tuple(),
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)));


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::ManagerStub,
    std::tuple< std::string>,
    std::tuple< std::string>,
    std::tuple< CommonAPI::DBus::StringDeployment>,
    std::tuple< CommonAPI::DBus::StringDeployment>

    > ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::findAdapterStubDispatcher(
    &ManagerStub::FindAdapter, "s",
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)));


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::ManagerStub,
    std::tuple< >,
    std::tuple< std::vector< std::string >>,
    std::tuple< >,
    std::tuple< CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >>

    > ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::listAdaptersStubDispatcher(
    &ManagerStub::ListAdapters, "as",
    std::make_tuple(),
    std::make_tuple(static_cast< CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >* >(nullptr)));

template <typename _Stub, typename... _Stubs>
void ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::firePropertyChangedEvent(const std::string& name, const ::v4::org::bluez::Manager::Variant& value) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>,
    CommonAPI::Deployable< ::v4::org::bluez::Manager::Variant, ::v4::org::bluez::Manager_::VariantDeployment_t>
    >>::sendSignal(
            *this,
            "PropertyChanged",
            "s(yv)",
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>(name, static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)),
    CommonAPI::Deployable< ::v4::org::bluez::Manager::Variant, ::v4::org::bluez::Manager_::VariantDeployment_t>(value, static_cast< ::v4::org::bluez::Manager_::VariantDeployment_t* >(nullptr))
    );
}

template <typename _Stub, typename... _Stubs>
void ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::fireAdapterAddedEvent(const std::string& adapter) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "AdapterAdded",
            "s",
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>(adapter, static_cast< CommonAPI::DBus::StringDeployment* >(nullptr))
    );
}

template <typename _Stub, typename... _Stubs>
void ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::fireAdapterRemovedEvent(const std::string& adapter) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "AdapterRemoved",
            "s",
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>(adapter, static_cast< CommonAPI::DBus::StringDeployment* >(nullptr))
    );
}

template <typename _Stub, typename... _Stubs>
void ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::fireDefaultAdapterChangedEvent(const std::string& adapter) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "DefaultAdapterChanged",
            "s",
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment>(adapter, static_cast< CommonAPI::DBus::StringDeployment* >(nullptr))
    );
}


template <typename _Stub = ::v4::org::bluez::ManagerStub, typename... _Stubs>
class ManagerDBusStubAdapter
    : public ManagerDBusStubAdapterInternal<_Stub, _Stubs...>,
      public std::enable_shared_from_this< ManagerDBusStubAdapter<_Stub, _Stubs...>> {
public:
    ManagerDBusStubAdapter(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
        : CommonAPI::DBus::DBusStubAdapter(
            _address,
            _connection,
            false),
          ManagerDBusStubAdapterInternal<_Stub, _Stubs...>(
            _address,
            _connection,
            _stub) {
    }
};

} // namespace bluez
} // namespace org
} // namespace v4

#endif // V4_ORG_BLUEZ_Manager_DBUS_STUB_ADAPTER_HPP_
