/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.10.v201611111523.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_E05_Manager_DBUS_STUB_ADAPTER_HPP_
#define V1_COMMONAPI_EXAMPLES_E05_Manager_DBUS_STUB_ADAPTER_HPP_

#include <v1/commonapi/examples/E05ManagerStub.hpp>
#include "v1/commonapi/examples/E05ManagerDBusDeployment.hpp"

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/DBus/DBusAddressTranslator.hpp>
#include <CommonAPI/DBus/DBusFactory.hpp>
#include <CommonAPI/DBus/DBusObjectManager.hpp>
#include <CommonAPI/DBus/DBusStubAdapterHelper.hpp>
#include <CommonAPI/DBus/DBusStubAdapter.hpp>
#include <CommonAPI/DBus/DBusDeployment.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v1 {
namespace commonapi {
namespace examples {

template <typename _Stub = ::v1::commonapi::examples::E05ManagerStub, typename... _Stubs>
class E05ManagerDBusStubAdapterInternal
    : public virtual E05ManagerStubAdapter,
      public CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...>
     {
public:
    typedef CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...> E05ManagerDBusStubAdapterHelper;

    ~E05ManagerDBusStubAdapterInternal() {
        deactivateManagedInstances();
        E05ManagerDBusStubAdapterHelper::deinit();
    }

    virtual bool hasFreedesktopProperties() {
        return false;
    }

    inline static const char* getInterface() {
        return E05Manager::getInterface();
    }

    void fireMyDevicesAttributeChanged(const std::vector< std::string >& value);

    bool registerManagedStubE05Device(std::shared_ptr< ::v1::commonapi::examples::E05DeviceStub>, const std::string&);
    bool deregisterManagedStubE05Device(const std::string&);
    std::set<std::string>& getE05DeviceInstances();

    bool registerManagedStubE05SpecialDevice(std::shared_ptr< ::v1::commonapi::examples::E05SpecialDeviceStub>, const std::string&);
    bool deregisterManagedStubE05SpecialDevice(const std::string&);
    std::set<std::string>& getE05SpecialDeviceInstances();

    void deactivateManagedInstances() {
    std::set<std::string>::iterator iter;
    std::set<std::string>::iterator iterNext;

    iter = registeredE05DeviceInstances.begin();
    while (iter != registeredE05DeviceInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubE05Device(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
    iter = registeredE05SpecialDeviceInstances.begin();
    while (iter != registeredE05SpecialDeviceInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubE05SpecialDevice(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
    }

    static CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v1::commonapi::examples::E05ManagerStub,
        CommonAPI::Version
        > getE05ManagerInterfaceVersionStubDispatcher;

    static CommonAPI::DBus::DBusGetAttributeStubDispatcher<
            ::v1::commonapi::examples::E05ManagerStub,
            std::vector< std::string >,
            CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >
            > getMyDevicesAttributeStubDispatcher;
    static CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
            ::v1::commonapi::examples::E05ManagerStub,
            std::vector< std::string >,
            CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >
            > setMyDevicesAttributeStubDispatcher;

    E05ManagerDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
    : CommonAPI::DBus::DBusStubAdapter(_address, _connection,true),
      E05ManagerDBusStubAdapterHelper(_address, _connection, true, _stub) {
        E05ManagerDBusStubAdapterHelper::addStubDispatcher({ "getMyDevicesAttribute", "" }, &getMyDevicesAttributeStubDispatcher);
        E05ManagerDBusStubAdapterHelper::addStubDispatcher({ "setMyDevicesAttribute", "as" }, &setMyDevicesAttributeStubDispatcher);
        E05ManagerDBusStubAdapterHelper::addStubDispatcher({ "getInterfaceVersion", "" }, &getE05ManagerInterfaceVersionStubDispatcher);
    }

protected:
    virtual const char* getMethodsDBusIntrospectionXmlData() const {
        static const std::string introspectionData =
            "<method name=\"getInterfaceVersion\">\n"
                "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
            "</method>\n"
            "<method name=\"getMyDevicesAttribute\">\n"
            "<arg name=\"value\" type=\"as\" direction=\"out\" />"
            "</method>\n"
            "<method name=\"setMyDevicesAttribute\">\n"
            "<arg name=\"requestedValue\" type=\"as\" direction=\"in\" />\n"
            "<arg name=\"setValue\" type=\"as\" direction=\"out\" />\n"
            "</method>\n"
            "<signal name=\"onMyDevicesAttributeChanged\">\n"
            "<arg name=\"changedValue\" type=\"as\" />\n"
            "</signal>\n"
            ;
        return introspectionData.c_str();
    }

private:
    std::set<std::string> registeredE05DeviceInstances;
    std::set<std::string> registeredE05SpecialDeviceInstances;
};


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
    ::v1::commonapi::examples::E05ManagerStub,
    CommonAPI::Version
    > E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::getE05ManagerInterfaceVersionStubDispatcher(&E05ManagerStub::getInterfaceVersion, "uu");

template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v1::commonapi::examples::E05ManagerStub,
        std::vector< std::string >,
        CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >
        > E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::getMyDevicesAttributeStubDispatcher(
            &::v1::commonapi::examples::E05ManagerStub::getMyDevicesAttribute
            , "as"
            );
template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
        ::v1::commonapi::examples::E05ManagerStub,
        std::vector< std::string >,
        CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >
        > E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::setMyDevicesAttributeStubDispatcher(
                &::v1::commonapi::examples::E05ManagerStub::getMyDevicesAttribute,
                &E05ManagerStubRemoteEvent::onRemoteSetMyDevicesAttribute,
                &E05ManagerStubRemoteEvent::onRemoteMyDevicesAttributeChanged
                ,&E05ManagerStubAdapter::fireMyDevicesAttributeChanged
                ,"as"
                );

template <typename _Stub, typename... _Stubs>
void E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::fireMyDevicesAttributeChanged(const std::vector< std::string >& value) {
    CommonAPI::Deployable< std::vector< std::string >, CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >> deployedValue(value, static_cast< CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >* >(nullptr));
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<
        std::vector< std::string >,
        CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >
    >
    >>
        ::sendSignal(
            *this,
            "onMyDevicesAttributeChanged",
            "as",
            deployedValue
    
    );
}

template <typename _Stub, typename... _Stubs>
bool E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::registerManagedStubE05Device(std::shared_ptr< ::v1::commonapi::examples::E05DeviceStub> _stub, const std::string &_instance) {
    if (registeredE05DeviceInstances.find(_instance) == registeredE05DeviceInstances.end()) {
        std::string itsAddress = "local:commonapi.examples.E05Device:v1_0:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string adapterObjectPath(CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath());

        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

        auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "commonapi.examples.E05Device:v1_0", itsDBusAddress, CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_);
        bool isRegistered = itsFactory->registerManagedService(stubAdapter);
        if (isRegistered) {
            bool isExported = CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
            if (isExported) {
                registeredE05DeviceInstances.insert(_instance);
                return true;
            } else {
                itsFactory->unregisterManagedService(itsAddress);
            }
        }
    }
    return false;
}
template <typename _Stub, typename... _Stubs>
bool E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::deregisterManagedStubE05Device(const std::string &_instance) {
    std::string itsAddress = "local:commonapi.examples.E05Device:v1_0:" + _instance;
    if (registeredE05DeviceInstances.find(_instance) != registeredE05DeviceInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredE05DeviceInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

template <typename _Stub, typename... _Stubs>
std::set<std::string>& E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::getE05DeviceInstances() {
    return registeredE05DeviceInstances;
}

template <typename _Stub, typename... _Stubs>
bool E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::registerManagedStubE05SpecialDevice(std::shared_ptr< ::v1::commonapi::examples::E05SpecialDeviceStub> _stub, const std::string &_instance) {
    if (registeredE05SpecialDeviceInstances.find(_instance) == registeredE05SpecialDeviceInstances.end()) {
        std::string itsAddress = "local:commonapi.examples.E05SpecialDevice:v1_0:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string adapterObjectPath(CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath());

        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

        auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "commonapi.examples.E05SpecialDevice:v1_0", itsDBusAddress, CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_);
        bool isRegistered = itsFactory->registerManagedService(stubAdapter);
        if (isRegistered) {
            bool isExported = CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
            if (isExported) {
                registeredE05SpecialDeviceInstances.insert(_instance);
                return true;
            } else {
                itsFactory->unregisterManagedService(itsAddress);
            }
        }
    }
    return false;
}
template <typename _Stub, typename... _Stubs>
bool E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::deregisterManagedStubE05SpecialDevice(const std::string &_instance) {
    std::string itsAddress = "local:commonapi.examples.E05SpecialDevice:v1_0:" + _instance;
    if (registeredE05SpecialDeviceInstances.find(_instance) != registeredE05SpecialDeviceInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredE05SpecialDeviceInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

template <typename _Stub, typename... _Stubs>
std::set<std::string>& E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::getE05SpecialDeviceInstances() {
    return registeredE05SpecialDeviceInstances;
}


template <typename _Stub = ::v1::commonapi::examples::E05ManagerStub, typename... _Stubs>
class E05ManagerDBusStubAdapter
    : public E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>,
      public std::enable_shared_from_this< E05ManagerDBusStubAdapter<_Stub, _Stubs...>> {
public:
    E05ManagerDBusStubAdapter(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
        : CommonAPI::DBus::DBusStubAdapter(
            _address,
            _connection,
            true),
          E05ManagerDBusStubAdapterInternal<_Stub, _Stubs...>(
            _address,
            _connection,
            _stub) {
    }
};

} // namespace examples
} // namespace commonapi
} // namespace v1

#endif // V1_COMMONAPI_EXAMPLES_E05_Manager_DBUS_STUB_ADAPTER_HPP_
