/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.10.v201611111521.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_Legacy_Test_STUB_DEFAULT_HPP_
#define V1_COMMONAPI_EXAMPLES_Legacy_Test_STUB_DEFAULT_HPP_


#include <CommonAPI/Export.hpp>

#include <v1/commonapi/examples/LegacyTestStub.hpp>
#include <sstream>

#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif

namespace v1 {
namespace commonapi {
namespace examples {

/**
 * Provides a default implementation for LegacyTestStubRemoteEvent and
 * LegacyTestStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class COMMONAPI_EXPORT_CLASS_EXPLICIT LegacyTestStubDefault
    : public virtual LegacyTestStub {
public:
    COMMONAPI_EXPORT LegacyTestStubDefault();

    COMMONAPI_EXPORT LegacyTestStubRemoteEvent* initStubAdapter(const std::shared_ptr< LegacyTestStubAdapter> &_adapter);

    COMMONAPI_EXPORT const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client);

    COMMONAPI_EXPORT virtual const std::string& getNopathAttribute();
    COMMONAPI_EXPORT virtual const std::string& getNopathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    COMMONAPI_EXPORT virtual void setNopathAttribute(std::string _value);
    COMMONAPI_EXPORT virtual void setNopathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
    COMMONAPI_EXPORT virtual const std::string& getObjectpathAttribute();
    COMMONAPI_EXPORT virtual const std::string& getObjectpathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    COMMONAPI_EXPORT virtual void setObjectpathAttribute(std::string _value);
    COMMONAPI_EXPORT virtual void setObjectpathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
    COMMONAPI_EXPORT virtual const std::string& getDefvalueAttribute();
    COMMONAPI_EXPORT virtual const std::string& getDefvalueAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    COMMONAPI_EXPORT virtual void setDefvalueAttribute(std::string _value);
    COMMONAPI_EXPORT virtual void setDefvalueAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);

    COMMONAPI_EXPORT virtual void test(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _plain, std::string _path, testReply_t _reply);
    COMMONAPI_EXPORT virtual void teststruct(const std::shared_ptr<CommonAPI::ClientId> _client, LegacyTest::pathstruct _pathsin, teststructReply_t _reply);
    COMMONAPI_EXPORT virtual void testunion(const std::shared_ptr<CommonAPI::ClientId> _client, int32_t _intin, LegacyTest::pathunion _pathuin, testunionReply_t _reply);

    COMMONAPI_EXPORT virtual void fireTestbEvent(const std::string &_plain3, const std::string &_path3);

    
protected:
    COMMONAPI_EXPORT virtual bool trySetNopathAttribute(std::string _value);
    COMMONAPI_EXPORT virtual bool validateNopathAttributeRequestedValue(const std::string &_value);
    COMMONAPI_EXPORT virtual void onRemoteNopathAttributeChanged();
    COMMONAPI_EXPORT virtual bool trySetObjectpathAttribute(std::string _value);
    COMMONAPI_EXPORT virtual bool validateObjectpathAttributeRequestedValue(const std::string &_value);
    COMMONAPI_EXPORT virtual void onRemoteObjectpathAttributeChanged();
    COMMONAPI_EXPORT virtual bool trySetDefvalueAttribute(std::string _value);
    COMMONAPI_EXPORT virtual bool validateDefvalueAttributeRequestedValue(const std::string &_value);
    COMMONAPI_EXPORT virtual void onRemoteDefvalueAttributeChanged();
    class COMMONAPI_EXPORT_CLASS_EXPLICIT RemoteEventHandler: public virtual LegacyTestStubRemoteEvent {
    public:
        COMMONAPI_EXPORT RemoteEventHandler(LegacyTestStubDefault *_defaultStub);

        COMMONAPI_EXPORT virtual bool onRemoteSetNopathAttribute(std::string _value);
        COMMONAPI_EXPORT virtual bool onRemoteSetNopathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        COMMONAPI_EXPORT virtual void onRemoteNopathAttributeChanged();

        COMMONAPI_EXPORT virtual bool onRemoteSetObjectpathAttribute(std::string _value);
        COMMONAPI_EXPORT virtual bool onRemoteSetObjectpathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        COMMONAPI_EXPORT virtual void onRemoteObjectpathAttributeChanged();

        COMMONAPI_EXPORT virtual bool onRemoteSetDefvalueAttribute(std::string _value);
        COMMONAPI_EXPORT virtual bool onRemoteSetDefvalueAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        COMMONAPI_EXPORT virtual void onRemoteDefvalueAttributeChanged();


    private:
        LegacyTestStubDefault *defaultStub_;
    };
private:
    LegacyTestStubDefault::RemoteEventHandler remoteEventHandler_;

    std::string nopathAttributeValue_ {};
    std::string objectpathAttributeValue_ {};
    std::string defvalueAttributeValue_ {};

    CommonAPI::Version interfaceVersion_;
};

} // namespace examples
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_EXAMPLES_Legacy_Test_STUB_DEFAULT
