/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.10.v201611111523.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_DBUS_STUB_ADAPTER_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_DBUS_STUB_ADAPTER_HPP_

#include <v2/org/freedesktop/UDisks2/FilesystemStub.hpp>
#include "v2/org/freedesktop/UDisks2/FilesystemDBusDeployment.hpp"
#include <v2/org/freedesktop/UDisks2/FilesystemDBusDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/DBus/DBusAddressTranslator.hpp>
#include <CommonAPI/DBus/DBusFactory.hpp>
#include <CommonAPI/DBus/DBusStubAdapterHelper.hpp>
#include <CommonAPI/DBus/DBusStubAdapter.hpp>
#include <CommonAPI/DBus/DBusDeployment.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

template <typename _Stub = ::v2::org::freedesktop::UDisks2::FilesystemStub, typename... _Stubs>
class FilesystemDBusStubAdapterInternal
    : public virtual FilesystemStubAdapter,
      public CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...>
     {
public:
    typedef CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...> FilesystemDBusStubAdapterHelper;

    ~FilesystemDBusStubAdapterInternal() {
        deactivateManagedInstances();
        FilesystemDBusStubAdapterHelper::deinit();
    }

    virtual bool hasFreedesktopProperties() {
        return false;
    }

    inline static const char* getInterface() {
        return Filesystem::getInterface();
    }

    void fireMountPointsAttributeChanged(const std::vector< ::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray >& value);

    void deactivateManagedInstances() {
    }

    static CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::FilesystemStub,
        CommonAPI::Version
        > getFilesystemInterfaceVersionStubDispatcher;

    static CommonAPI::DBus::DBusGetAttributeStubDispatcher<
            ::v2::org::freedesktop::UDisks2::FilesystemStub,
            std::vector< ::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray >,
            CommonAPI::DBus::ArrayDeployment< ::v2::org::freedesktop::UDisks2::Filesystem_::tMountPointsArrayDeployment_t >
            > getMountPointsAttributeStubDispatcher;
    static CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
            ::v2::org::freedesktop::UDisks2::FilesystemStub,
            std::vector< ::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray >,
            CommonAPI::DBus::ArrayDeployment< ::v2::org::freedesktop::UDisks2::Filesystem_::tMountPointsArrayDeployment_t >
            > setMountPointsAttributeStubDispatcher;

    /**
     * description: array generated for DBus argument MountPoints
     */
    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v2::org::freedesktop::UDisks2::FilesystemStub,
        std::tuple< std::string, Filesystem::tSetLabel_optionsDict>,
        std::tuple< >,
        std::tuple< CommonAPI::DBus::StringDeployment, ::v2::org::freedesktop::UDisks2::Filesystem_::tSetLabel_optionsDictDeployment_t>,
        std::tuple< >
    
        > setLabelStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v2::org::freedesktop::UDisks2::FilesystemStub,
        std::tuple< Filesystem::tMount_optionsDict>,
        std::tuple< std::string>,
        std::tuple< ::v2::org::freedesktop::UDisks2::Filesystem_::tMount_optionsDictDeployment_t>,
        std::tuple< CommonAPI::DBus::StringDeployment>
    
        > mountStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v2::org::freedesktop::UDisks2::FilesystemStub,
        std::tuple< Filesystem::tUnmount_optionsDict>,
        std::tuple< >,
        std::tuple< ::v2::org::freedesktop::UDisks2::Filesystem_::tUnmount_optionsDictDeployment_t>,
        std::tuple< >
    
        > unmountStubDispatcher;

    FilesystemDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
    : CommonAPI::DBus::DBusStubAdapter(_address, _connection,false),
      FilesystemDBusStubAdapterHelper(_address, _connection, false, _stub) {
        FilesystemDBusStubAdapterHelper::addStubDispatcher({ "getMountPointsAttribute", "" }, &getMountPointsAttributeStubDispatcher);
        FilesystemDBusStubAdapterHelper::addStubDispatcher({ "setMountPointsAttribute", "aay" }, &setMountPointsAttributeStubDispatcher);
        /**
         * description: array generated for DBus argument MountPoints
         */
        FilesystemDBusStubAdapterHelper::addStubDispatcher({ "SetLabel", "sa{s(yv)}" }, &setLabelStubDispatcher);
        FilesystemDBusStubAdapterHelper::addStubDispatcher({ "Mount", "a{s(yv)}" }, &mountStubDispatcher);
        FilesystemDBusStubAdapterHelper::addStubDispatcher({ "Unmount", "a{s(yv)}" }, &unmountStubDispatcher);
        FilesystemDBusStubAdapterHelper::addStubDispatcher({ "getInterfaceVersion", "" }, &getFilesystemInterfaceVersionStubDispatcher);
    }

protected:
    virtual const char* getMethodsDBusIntrospectionXmlData() const {
        static const std::string introspectionData =
            "<method name=\"getInterfaceVersion\">\n"
                "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
            "</method>\n"
            "<method name=\"getMountPointsAttribute\">\n"
            "<arg name=\"value\" type=\"aay\" direction=\"out\" />"
            "</method>\n"
            "<method name=\"setMountPointsAttribute\">\n"
            "<arg name=\"requestedValue\" type=\"aay\" direction=\"in\" />\n"
            "<arg name=\"setValue\" type=\"aay\" direction=\"out\" />\n"
            "</method>\n"
            "<signal name=\"onMountPointsAttributeChanged\">\n"
            "<arg name=\"changedValue\" type=\"aay\" />\n"
            "</signal>\n"
            /**
             * description: array generated for DBus argument MountPoints
             */
            "<method name=\"SetLabel\">\n"
            "<arg name=\"_label\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_options\" type=\"a{s(yv)}\" direction=\"in\" />\n"
            "</method>\n"
            "<method name=\"Mount\">\n"
            "<arg name=\"_options\" type=\"a{s(yv)}\" direction=\"in\" />\n"
            "<arg name=\"_mount_path\" type=\"s\" direction=\"out\" />\n"
            "</method>\n"
            "<method name=\"Unmount\">\n"
            "<arg name=\"_options\" type=\"a{s(yv)}\" direction=\"in\" />\n"
            "</method>\n"
            ;
        return introspectionData.c_str();
    }

private:
};


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
    ::v2::org::freedesktop::UDisks2::FilesystemStub,
    CommonAPI::Version
    > FilesystemDBusStubAdapterInternal<_Stub, _Stubs...>::getFilesystemInterfaceVersionStubDispatcher(&FilesystemStub::getInterfaceVersion, "uu");

template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::FilesystemStub,
        std::vector< ::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray >,
        CommonAPI::DBus::ArrayDeployment< ::v2::org::freedesktop::UDisks2::Filesystem_::tMountPointsArrayDeployment_t >
        > FilesystemDBusStubAdapterInternal<_Stub, _Stubs...>::getMountPointsAttributeStubDispatcher(
            &::v2::org::freedesktop::UDisks2::FilesystemStub::getMountPointsAttribute
            , "aay"
            );
template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::FilesystemStub,
        std::vector< ::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray >,
        CommonAPI::DBus::ArrayDeployment< ::v2::org::freedesktop::UDisks2::Filesystem_::tMountPointsArrayDeployment_t >
        > FilesystemDBusStubAdapterInternal<_Stub, _Stubs...>::setMountPointsAttributeStubDispatcher(
                &::v2::org::freedesktop::UDisks2::FilesystemStub::getMountPointsAttribute,
                &FilesystemStubRemoteEvent::onRemoteSetMountPointsAttribute,
                &FilesystemStubRemoteEvent::onRemoteMountPointsAttributeChanged
                ,&FilesystemStubAdapter::fireMountPointsAttributeChanged
                ,"aay"
                );


/**
 * description: array generated for DBus argument MountPoints
 */
template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v2::org::freedesktop::UDisks2::FilesystemStub,
    std::tuple< std::string, Filesystem::tSetLabel_optionsDict>,
    std::tuple< >,
    std::tuple< CommonAPI::DBus::StringDeployment, ::v2::org::freedesktop::UDisks2::Filesystem_::tSetLabel_optionsDictDeployment_t>,
    std::tuple< >

    > FilesystemDBusStubAdapterInternal<_Stub, _Stubs...>::setLabelStubDispatcher(
    &FilesystemStub::SetLabel, "",
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr), static_cast< ::v2::org::freedesktop::UDisks2::Filesystem_::tSetLabel_optionsDictDeployment_t* >(nullptr)),
    std::make_tuple());


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v2::org::freedesktop::UDisks2::FilesystemStub,
    std::tuple< Filesystem::tMount_optionsDict>,
    std::tuple< std::string>,
    std::tuple< ::v2::org::freedesktop::UDisks2::Filesystem_::tMount_optionsDictDeployment_t>,
    std::tuple< CommonAPI::DBus::StringDeployment>

    > FilesystemDBusStubAdapterInternal<_Stub, _Stubs...>::mountStubDispatcher(
    &FilesystemStub::Mount, "s",
    std::make_tuple(static_cast< ::v2::org::freedesktop::UDisks2::Filesystem_::tMount_optionsDictDeployment_t* >(nullptr)),
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)));


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v2::org::freedesktop::UDisks2::FilesystemStub,
    std::tuple< Filesystem::tUnmount_optionsDict>,
    std::tuple< >,
    std::tuple< ::v2::org::freedesktop::UDisks2::Filesystem_::tUnmount_optionsDictDeployment_t>,
    std::tuple< >

    > FilesystemDBusStubAdapterInternal<_Stub, _Stubs...>::unmountStubDispatcher(
    &FilesystemStub::Unmount, "",
    std::make_tuple(static_cast< ::v2::org::freedesktop::UDisks2::Filesystem_::tUnmount_optionsDictDeployment_t* >(nullptr)),
    std::make_tuple());

template <typename _Stub, typename... _Stubs>
void FilesystemDBusStubAdapterInternal<_Stub, _Stubs...>::fireMountPointsAttributeChanged(const std::vector< ::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray >& value) {
    CommonAPI::Deployable< std::vector< Filesystem::tMountPointsArray >, CommonAPI::DBus::ArrayDeployment< ::v2::org::freedesktop::UDisks2::Filesystem_::tMountPointsArrayDeployment_t >> deployedValue(value, static_cast< CommonAPI::DBus::ArrayDeployment< ::v2::org::freedesktop::UDisks2::Filesystem_::tMountPointsArrayDeployment_t >* >(nullptr));
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<
        std::vector< ::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray >,
        CommonAPI::DBus::ArrayDeployment< ::v2::org::freedesktop::UDisks2::Filesystem_::tMountPointsArrayDeployment_t >
    >
    >>
        ::sendSignal(
            *this,
            "onMountPointsAttributeChanged",
            "aay",
            deployedValue
    
    );
}


template <typename _Stub = ::v2::org::freedesktop::UDisks2::FilesystemStub, typename... _Stubs>
class FilesystemDBusStubAdapter
    : public FilesystemDBusStubAdapterInternal<_Stub, _Stubs...>,
      public std::enable_shared_from_this< FilesystemDBusStubAdapter<_Stub, _Stubs...>> {
public:
    FilesystemDBusStubAdapter(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
        : CommonAPI::DBus::DBusStubAdapter(
            _address,
            _connection,
            false),
          FilesystemDBusStubAdapterInternal<_Stub, _Stubs...>(
            _address,
            _connection,
            _stub) {
    }
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_DBUS_STUB_ADAPTER_HPP_
