/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.10.v201611111523.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Manager_DBUS_STUB_ADAPTER_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Manager_DBUS_STUB_ADAPTER_HPP_

#include <v2/org/freedesktop/UDisks2/ManagerStub.hpp>
#include "v2/org/freedesktop/UDisks2/ManagerDBusDeployment.hpp"
#include <v2/org/freedesktop/UDisks2/ManagerDBusDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/DBus/DBusAddressTranslator.hpp>
#include <CommonAPI/DBus/DBusFactory.hpp>
#include <CommonAPI/DBus/DBusStubAdapterHelper.hpp>
#include <CommonAPI/DBus/DBusStubAdapter.hpp>
#include <CommonAPI/DBus/DBusDeployment.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

template <typename _Stub = ::v2::org::freedesktop::UDisks2::ManagerStub, typename... _Stubs>
class ManagerDBusStubAdapterInternal
    : public virtual ManagerStubAdapter,
      public CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...>
     {
public:
    typedef CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...> ManagerDBusStubAdapterHelper;

    ~ManagerDBusStubAdapterInternal() {
        deactivateManagedInstances();
        ManagerDBusStubAdapterHelper::deinit();
    }

    virtual bool hasFreedesktopProperties() {
        return false;
    }

    inline static const char* getInterface() {
        return Manager::getInterface();
    }

    void fireVersionAttributeChanged(const std::string& value);

    void deactivateManagedInstances() {
    }

    static CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::ManagerStub,
        CommonAPI::Version
        > getManagerInterfaceVersionStubDispatcher;

    static CommonAPI::DBus::DBusGetAttributeStubDispatcher<
            ::v2::org::freedesktop::UDisks2::ManagerStub,
            std::string,
            CommonAPI::DBus::StringDeployment
            > getVersionAttributeStubDispatcher;
    static CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
            ::v2::org::freedesktop::UDisks2::ManagerStub,
            std::string,
            CommonAPI::DBus::StringDeployment
            > setVersionAttributeStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v2::org::freedesktop::UDisks2::ManagerStub,
        std::tuple< uint32_t, Manager::tLoopSetup_optionsDict>,
        std::tuple< std::string>,
        std::tuple< CommonAPI::EmptyDeployment, ::v2::org::freedesktop::UDisks2::Manager_::tLoopSetup_optionsDictDeployment_t>,
        std::tuple< CommonAPI::DBus::StringDeployment>
    
        > loopSetupStubDispatcher;

    
    static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
        ::v2::org::freedesktop::UDisks2::ManagerStub,
        std::tuple< std::vector< std::string >, std::string, std::string, uint64_t, Manager::tMDRaidCreate_optionsDict>,
        std::tuple< std::string>,
        std::tuple< CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >, CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment, CommonAPI::EmptyDeployment, ::v2::org::freedesktop::UDisks2::Manager_::tMDRaidCreate_optionsDictDeployment_t>,
        std::tuple< CommonAPI::DBus::StringDeployment>
    
        > mDRaidCreateStubDispatcher;

    ManagerDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
    : CommonAPI::DBus::DBusStubAdapter(_address, _connection,false),
      ManagerDBusStubAdapterHelper(_address, _connection, false, _stub) {
        ManagerDBusStubAdapterHelper::addStubDispatcher({ "getVersionAttribute", "" }, &getVersionAttributeStubDispatcher);
        ManagerDBusStubAdapterHelper::addStubDispatcher({ "setVersionAttribute", "s" }, &setVersionAttributeStubDispatcher);
        ManagerDBusStubAdapterHelper::addStubDispatcher({ "LoopSetup", "ua{s(yv)}" }, &loopSetupStubDispatcher);
        ManagerDBusStubAdapterHelper::addStubDispatcher({ "MDRaidCreate", "asssta{s(yv)}" }, &mDRaidCreateStubDispatcher);
        ManagerDBusStubAdapterHelper::addStubDispatcher({ "getInterfaceVersion", "" }, &getManagerInterfaceVersionStubDispatcher);
    }

protected:
    virtual const char* getMethodsDBusIntrospectionXmlData() const {
        static const std::string introspectionData =
            "<method name=\"getInterfaceVersion\">\n"
                "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
            "</method>\n"
            "<method name=\"getVersionAttribute\">\n"
            "<arg name=\"value\" type=\"s\" direction=\"out\" />"
            "</method>\n"
            "<method name=\"setVersionAttribute\">\n"
            "<arg name=\"requestedValue\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"setValue\" type=\"s\" direction=\"out\" />\n"
            "</method>\n"
            "<signal name=\"onVersionAttributeChanged\">\n"
            "<arg name=\"changedValue\" type=\"s\" />\n"
            "</signal>\n"
            "<method name=\"LoopSetup\">\n"
            "<arg name=\"_fd\" type=\"u\" direction=\"in\" />\n"
            "<arg name=\"_options\" type=\"a{s(yv)}\" direction=\"in\" />\n"
            "<arg name=\"_resulting_device\" type=\"s\" direction=\"out\" />\n"
            "</method>\n"
            "<method name=\"MDRaidCreate\">\n"
            "<arg name=\"_blocks\" type=\"as\" direction=\"in\" />\n"
            "<arg name=\"_level\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_name\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_chunk\" type=\"t\" direction=\"in\" />\n"
            "<arg name=\"_options\" type=\"a{s(yv)}\" direction=\"in\" />\n"
            "<arg name=\"_resulting_array\" type=\"s\" direction=\"out\" />\n"
            "</method>\n"
            ;
        return introspectionData.c_str();
    }

private:
};


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
    ::v2::org::freedesktop::UDisks2::ManagerStub,
    CommonAPI::Version
    > ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::getManagerInterfaceVersionStubDispatcher(&ManagerStub::getInterfaceVersion, "uu");

template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::ManagerStub,
        std::string,
        CommonAPI::DBus::StringDeployment
        > ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::getVersionAttributeStubDispatcher(
            &::v2::org::freedesktop::UDisks2::ManagerStub::getVersionAttribute
            , "s"
            );
template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::ManagerStub,
        std::string,
        CommonAPI::DBus::StringDeployment
        > ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::setVersionAttributeStubDispatcher(
                &::v2::org::freedesktop::UDisks2::ManagerStub::getVersionAttribute,
                &ManagerStubRemoteEvent::onRemoteSetVersionAttribute,
                &ManagerStubRemoteEvent::onRemoteVersionAttributeChanged
                ,&ManagerStubAdapter::fireVersionAttributeChanged
                ,"s"
                );


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v2::org::freedesktop::UDisks2::ManagerStub,
    std::tuple< uint32_t, Manager::tLoopSetup_optionsDict>,
    std::tuple< std::string>,
    std::tuple< CommonAPI::EmptyDeployment, ::v2::org::freedesktop::UDisks2::Manager_::tLoopSetup_optionsDictDeployment_t>,
    std::tuple< CommonAPI::DBus::StringDeployment>

    > ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::loopSetupStubDispatcher(
    &ManagerStub::LoopSetup, "s",
    std::make_tuple(static_cast< CommonAPI::EmptyDeployment* >(nullptr), static_cast< ::v2::org::freedesktop::UDisks2::Manager_::tLoopSetup_optionsDictDeployment_t* >(nullptr)),
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)));


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v2::org::freedesktop::UDisks2::ManagerStub,
    std::tuple< std::vector< std::string >, std::string, std::string, uint64_t, Manager::tMDRaidCreate_optionsDict>,
    std::tuple< std::string>,
    std::tuple< CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >, CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment, CommonAPI::EmptyDeployment, ::v2::org::freedesktop::UDisks2::Manager_::tMDRaidCreate_optionsDictDeployment_t>,
    std::tuple< CommonAPI::DBus::StringDeployment>

    > ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::mDRaidCreateStubDispatcher(
    &ManagerStub::MDRaidCreate, "s",
    std::make_tuple(static_cast< CommonAPI::DBus::ArrayDeployment< CommonAPI::DBus::StringDeployment >* >(nullptr), static_cast< CommonAPI::DBus::StringDeployment* >(nullptr), static_cast< CommonAPI::DBus::StringDeployment* >(nullptr), static_cast< CommonAPI::EmptyDeployment* >(nullptr), static_cast< ::v2::org::freedesktop::UDisks2::Manager_::tMDRaidCreate_optionsDictDeployment_t* >(nullptr)),
    std::make_tuple(static_cast< CommonAPI::DBus::StringDeployment* >(nullptr)));

template <typename _Stub, typename... _Stubs>
void ManagerDBusStubAdapterInternal<_Stub, _Stubs...>::fireVersionAttributeChanged(const std::string& value) {
    CommonAPI::Deployable< std::string, CommonAPI::DBus::StringDeployment> deployedValue(value, static_cast< CommonAPI::DBus::StringDeployment* >(nullptr));
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<
        std::string,
        CommonAPI::DBus::StringDeployment
    >
    >>
        ::sendSignal(
            *this,
            "onVersionAttributeChanged",
            "s",
            deployedValue
    
    );
}


template <typename _Stub = ::v2::org::freedesktop::UDisks2::ManagerStub, typename... _Stubs>
class ManagerDBusStubAdapter
    : public ManagerDBusStubAdapterInternal<_Stub, _Stubs...>,
      public std::enable_shared_from_this< ManagerDBusStubAdapter<_Stub, _Stubs...>> {
public:
    ManagerDBusStubAdapter(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
        : CommonAPI::DBus::DBusStubAdapter(
            _address,
            _connection,
            false),
          ManagerDBusStubAdapterInternal<_Stub, _Stubs...>(
            _address,
            _connection,
            _stub) {
    }
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Manager_DBUS_STUB_ADAPTER_HPP_
