/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.10.v201611111523.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Root_DBUS_STUB_ADAPTER_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Root_DBUS_STUB_ADAPTER_HPP_

#include <v2/org/freedesktop/UDisks2/RootStub.hpp>
#include "v2/org/freedesktop/UDisks2/RootDBusDeployment.hpp"

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/DBus/DBusAddressTranslator.hpp>
#include <CommonAPI/DBus/DBusFactory.hpp>
#include <CommonAPI/DBus/DBusObjectManager.hpp>
#include <CommonAPI/DBus/DBusStubAdapterHelper.hpp>
#include <CommonAPI/DBus/DBusStubAdapter.hpp>
#include <CommonAPI/DBus/DBusDeployment.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

template <typename _Stub = ::v2::org::freedesktop::UDisks2::RootStub, typename... _Stubs>
class RootDBusStubAdapterInternal
    : public virtual RootStubAdapter,
      public CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...>
     {
public:
    typedef CommonAPI::DBus::DBusStubAdapterHelper< _Stub, _Stubs...> RootDBusStubAdapterHelper;

    ~RootDBusStubAdapterInternal() {
        deactivateManagedInstances();
        RootDBusStubAdapterHelper::deinit();
    }

    virtual bool hasFreedesktopProperties() {
        return false;
    }

    inline static const char* getInterface() {
        return Root::getInterface();
    }

    bool registerManagedStubDrive(std::shared_ptr< ::v2::org::freedesktop::UDisks2::DriveStub>, const std::string&);
    bool deregisterManagedStubDrive(const std::string&);
    std::set<std::string>& getDriveInstances();

    bool registerManagedStubBlock(std::shared_ptr< ::v2::org::freedesktop::UDisks2::BlockStub>, const std::string&);
    bool deregisterManagedStubBlock(const std::string&);
    std::set<std::string>& getBlockInstances();

    bool registerManagedStubFilesystem(std::shared_ptr< ::v2::org::freedesktop::UDisks2::FilesystemStub>, const std::string&);
    bool deregisterManagedStubFilesystem(const std::string&);
    std::set<std::string>& getFilesystemInstances();

    bool registerManagedStubPartition(std::shared_ptr< ::v2::org::freedesktop::UDisks2::PartitionStub>, const std::string&);
    bool deregisterManagedStubPartition(const std::string&);
    std::set<std::string>& getPartitionInstances();

    void deactivateManagedInstances() {
    std::set<std::string>::iterator iter;
    std::set<std::string>::iterator iterNext;

    iter = registeredDriveInstances.begin();
    while (iter != registeredDriveInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubDrive(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
    iter = registeredBlockInstances.begin();
    while (iter != registeredBlockInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubBlock(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
    iter = registeredFilesystemInstances.begin();
    while (iter != registeredFilesystemInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubFilesystem(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
    iter = registeredPartitionInstances.begin();
    while (iter != registeredPartitionInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubPartition(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
    }

    static CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::RootStub,
        CommonAPI::Version
        > getRootInterfaceVersionStubDispatcher;

    RootDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
    : CommonAPI::DBus::DBusStubAdapter(_address, _connection,true),
      RootDBusStubAdapterHelper(_address, _connection, true, _stub) {
        RootDBusStubAdapterHelper::addStubDispatcher({ "getInterfaceVersion", "" }, &getRootInterfaceVersionStubDispatcher);
    }

protected:
    virtual const char* getMethodsDBusIntrospectionXmlData() const {
        static const std::string introspectionData =
            "<method name=\"getInterfaceVersion\">\n"
                "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
            "</method>\n"
            ""
            ;
        return introspectionData.c_str();
    }

private:
    std::set<std::string> registeredDriveInstances;
    std::set<std::string> registeredBlockInstances;
    std::set<std::string> registeredFilesystemInstances;
    std::set<std::string> registeredPartitionInstances;
};


template <typename _Stub, typename... _Stubs>
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
    ::v2::org::freedesktop::UDisks2::RootStub,
    CommonAPI::Version
    > RootDBusStubAdapterInternal<_Stub, _Stubs...>::getRootInterfaceVersionStubDispatcher(&RootStub::getInterfaceVersion, "uu");

template <typename _Stub, typename... _Stubs>
bool RootDBusStubAdapterInternal<_Stub, _Stubs...>::registerManagedStubDrive(std::shared_ptr< ::v2::org::freedesktop::UDisks2::DriveStub> _stub, const std::string &_instance) {
    if (registeredDriveInstances.find(_instance) == registeredDriveInstances.end()) {
        std::string itsAddress = "local:org.freedesktop.UDisks2.Drive:v2_1:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string adapterObjectPath(CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath());

        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

        auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "org.freedesktop.UDisks2.Drive:v2_1", itsDBusAddress, CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_);
        bool isRegistered = itsFactory->registerManagedService(stubAdapter);
        if (isRegistered) {
            bool isExported = CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
            if (isExported) {
                registeredDriveInstances.insert(_instance);
                return true;
            } else {
                itsFactory->unregisterManagedService(itsAddress);
            }
        }
    }
    return false;
}
template <typename _Stub, typename... _Stubs>
bool RootDBusStubAdapterInternal<_Stub, _Stubs...>::deregisterManagedStubDrive(const std::string &_instance) {
    std::string itsAddress = "local:org.freedesktop.UDisks2.Drive:v2_1:" + _instance;
    if (registeredDriveInstances.find(_instance) != registeredDriveInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredDriveInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

template <typename _Stub, typename... _Stubs>
std::set<std::string>& RootDBusStubAdapterInternal<_Stub, _Stubs...>::getDriveInstances() {
    return registeredDriveInstances;
}

template <typename _Stub, typename... _Stubs>
bool RootDBusStubAdapterInternal<_Stub, _Stubs...>::registerManagedStubBlock(std::shared_ptr< ::v2::org::freedesktop::UDisks2::BlockStub> _stub, const std::string &_instance) {
    if (registeredBlockInstances.find(_instance) == registeredBlockInstances.end()) {
        std::string itsAddress = "local:org.freedesktop.UDisks2.Block:v2_1:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string adapterObjectPath(CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath());

        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

        auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "org.freedesktop.UDisks2.Block:v2_1", itsDBusAddress, CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_);
        bool isRegistered = itsFactory->registerManagedService(stubAdapter);
        if (isRegistered) {
            bool isExported = CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
            if (isExported) {
                registeredBlockInstances.insert(_instance);
                return true;
            } else {
                itsFactory->unregisterManagedService(itsAddress);
            }
        }
    }
    return false;
}
template <typename _Stub, typename... _Stubs>
bool RootDBusStubAdapterInternal<_Stub, _Stubs...>::deregisterManagedStubBlock(const std::string &_instance) {
    std::string itsAddress = "local:org.freedesktop.UDisks2.Block:v2_1:" + _instance;
    if (registeredBlockInstances.find(_instance) != registeredBlockInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredBlockInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

template <typename _Stub, typename... _Stubs>
std::set<std::string>& RootDBusStubAdapterInternal<_Stub, _Stubs...>::getBlockInstances() {
    return registeredBlockInstances;
}

template <typename _Stub, typename... _Stubs>
bool RootDBusStubAdapterInternal<_Stub, _Stubs...>::registerManagedStubFilesystem(std::shared_ptr< ::v2::org::freedesktop::UDisks2::FilesystemStub> _stub, const std::string &_instance) {
    if (registeredFilesystemInstances.find(_instance) == registeredFilesystemInstances.end()) {
        std::string itsAddress = "local:org.freedesktop.UDisks2.Filesystem:v2_1:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string adapterObjectPath(CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath());

        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

        auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "org.freedesktop.UDisks2.Filesystem:v2_1", itsDBusAddress, CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_);
        bool isRegistered = itsFactory->registerManagedService(stubAdapter);
        if (isRegistered) {
            bool isExported = CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
            if (isExported) {
                registeredFilesystemInstances.insert(_instance);
                return true;
            } else {
                itsFactory->unregisterManagedService(itsAddress);
            }
        }
    }
    return false;
}
template <typename _Stub, typename... _Stubs>
bool RootDBusStubAdapterInternal<_Stub, _Stubs...>::deregisterManagedStubFilesystem(const std::string &_instance) {
    std::string itsAddress = "local:org.freedesktop.UDisks2.Filesystem:v2_1:" + _instance;
    if (registeredFilesystemInstances.find(_instance) != registeredFilesystemInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredFilesystemInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

template <typename _Stub, typename... _Stubs>
std::set<std::string>& RootDBusStubAdapterInternal<_Stub, _Stubs...>::getFilesystemInstances() {
    return registeredFilesystemInstances;
}

template <typename _Stub, typename... _Stubs>
bool RootDBusStubAdapterInternal<_Stub, _Stubs...>::registerManagedStubPartition(std::shared_ptr< ::v2::org::freedesktop::UDisks2::PartitionStub> _stub, const std::string &_instance) {
    if (registeredPartitionInstances.find(_instance) == registeredPartitionInstances.end()) {
        std::string itsAddress = "local:org.freedesktop.UDisks2.Partition:v2_1:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string adapterObjectPath(CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath());

        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

        auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "org.freedesktop.UDisks2.Partition:v2_1", itsDBusAddress, CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_);
        bool isRegistered = itsFactory->registerManagedService(stubAdapter);
        if (isRegistered) {
            bool isExported = CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
            if (isExported) {
                registeredPartitionInstances.insert(_instance);
                return true;
            } else {
                itsFactory->unregisterManagedService(itsAddress);
            }
        }
    }
    return false;
}
template <typename _Stub, typename... _Stubs>
bool RootDBusStubAdapterInternal<_Stub, _Stubs...>::deregisterManagedStubPartition(const std::string &_instance) {
    std::string itsAddress = "local:org.freedesktop.UDisks2.Partition:v2_1:" + _instance;
    if (registeredPartitionInstances.find(_instance) != registeredPartitionInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                CommonAPI::DBus::DBusStubAdapterHelper<_Stub, _Stubs...>::getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredPartitionInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

template <typename _Stub, typename... _Stubs>
std::set<std::string>& RootDBusStubAdapterInternal<_Stub, _Stubs...>::getPartitionInstances() {
    return registeredPartitionInstances;
}


template <typename _Stub = ::v2::org::freedesktop::UDisks2::RootStub, typename... _Stubs>
class RootDBusStubAdapter
    : public RootDBusStubAdapterInternal<_Stub, _Stubs...>,
      public std::enable_shared_from_this< RootDBusStubAdapter<_Stub, _Stubs...>> {
public:
    RootDBusStubAdapter(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<_Stub> &_stub)
        : CommonAPI::DBus::DBusStubAdapter(
            _address,
            _connection,
            true),
          RootDBusStubAdapterInternal<_Stub, _Stubs...>(
            _address,
            _connection,
            _stub) {
    }
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Root_DBUS_STUB_ADAPTER_HPP_
